[PATCH] ext4: Regression test for corruption during on-line resize

[Date Prev] [Date Next] [Thread Prev] [Thread Next] [Date Index] [Thread Index]



Regression test for:
	a6b3bfe176e8 ext4: fix corruption during on-line resize

Signed-off-by: Srivathsa Dara <srivathsa.d.dara@xxxxxxxxxx>
---
 tests/ext4/060     | 43 +++++++++++++++++++++++++++++++++++++++++++
 tests/ext4/060.out |  2 ++
 2 files changed, 45 insertions(+)
 create mode 100755 tests/ext4/060
 create mode 100644 tests/ext4/060.out

diff --git a/tests/ext4/060 b/tests/ext4/060
new file mode 100755
index 00000000..440748ea
--- /dev/null
+++ b/tests/ext4/060
@@ -0,0 +1,43 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2024 Oracle.  All Rights Reserved.
+#
+# FS QA Test 060
+#
+# This test ensures that kernel avoids FS corruption while online
+# resizing an ext4 filesystem with disabled resize_inode feature.
+#
+# The commit a6b3bfe176e8 ("ext4: fix corruption during on-line resize")
+# stops the corruption.
+#
+
+. ./common/preamble
+_begin_fstest auto resize quick
+
+_supported_fs ext4
+_fixed_by_kernel_commit a6b3bfe176e8 \
+	"ext4: fix corruption during on-line resize"
+
+_require_command "$RESIZE2FS_PROG" resize2fs
+_require_command "$E2FSCK_PROG" e2fsck
+_require_scratch_size_nocheck $((9* 1024 * 1024))
+
+# Initialize an EXT4 filesystem with the resize_inode feature disabled,
+# and a size of 128MiB less than 8GiB, i.e., short of 1 block group in
+# an 8GiB filesystem.
+
+dev_size=$((8* 1024 * 1024 * 1024 - 128 * 1024 * 1024))
+MKFS_OPTIONS="-O ^resize_inode $MKFS_OPTIONS" _scratch_mkfs_sized $dev_size \
+	>>$seqres.full 2>&1
+
+_scratch_mount
+
+# Perform online-resize
+$RESIZE2FS_PROG $SCRATCH_DEV 9G >> $seqres.full 2>&1
+
+$E2FSCK_PROG -fn $SCRATCH_DEV >> $seqres.full 2>&1 || _fail "Filesystem corrupted"
+
+echo "Silence is golden"
+
+status=0
+exit
diff --git a/tests/ext4/060.out b/tests/ext4/060.out
new file mode 100644
index 00000000..8ffce4de
--- /dev/null
+++ b/tests/ext4/060.out
@@ -0,0 +1,2 @@
+QA output created by 060
+Silence is golden
-- 
2.39.3





[Index of Archives]     [Linux Filesystems Development]     [Linux NFS]     [Linux NILFS]     [Linux USB Devel]     [Linux Audio Users]     [Yosemite News]     [Linux Kernel]     [Linux SCSI]

  Powered by Linux